#include <stdio.h>
#include <sys/syscall.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>

void 
usage(char *name)
{
	printf("Usage: %s CONTROL_SYSCALL ACTION [[UID [PATH | FILE]] | [POLICY]]\n\n", name);
}

int 
main(int argc, char *argv[])
{
	struct stat     ss;
	if (argc < 3) {
		usage(argv[0]);
		return -1;
	}
	if (((atoi(argv[2]) == 1) || (atoi(argv[2]) == 5)) && (argc != 5)) {
		usage(argv[0]);
		return -1;
	}
	if (((atoi(argv[2]) == 2) || (atoi(argv[2]) == 4) || (atoi(argv[2]) == 6)) && (argc != 4)) {
		usage(argv[0]);
		return -1;
	}
	if (((atoi(argv[2]) == 3) || (atoi(argv[2]) == 7)) && (argc != 3)) {
		usage(argv[0]);
		return -1;
	}
	switch (atoi(argv[2])) {
	case 1:
		syscall(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]), argv[4], NULL);
		break;
	case 2:
		syscall(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]), NULL, NULL);
		break;
	case 3:
		syscall(atoi(argv[1]), atoi(argv[2]), 0, NULL, NULL);
		break;
	case 4:
		syscall(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]), NULL, NULL);
		break;
	case 5:
		if (stat(argv[4], &ss) == -1) {
			printf("Cannot stat %s\n", argv[4]);
			return -1;
		}
		syscall(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]), ss.st_ino, ss.st_dev);
		break;
	case 6:
		syscall(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]), NULL, NULL);
		break;
	case 7:
		syscall(atoi(argv[1]), atoi(argv[2]), 0, 0, NULL);
		break;
	default:
		usage(argv[0]);
		return -2;
	}
	return 0;
}
