#include "kefinodelist.h"
#include <sys/null.h>
#include <sys/malloc.h>
#include <sys/systm.h>

struct ielem   *
iaddelem(struct ielem * a, int uid, ino_t inode, dev_t device)
{
	struct ielem   *b;
	b = (struct ielem *) malloc(sizeof(struct ielem), M_TEMP, M_WAITOK);
	b->uid = uid;
	b->inode = inode;
	b->device = device;
	b->next = NULL;
	b->prev = a;
	if (a != NULL) {
		while (a->next != NULL)
			a = a->next;
		a->next = b;
	}
	return b;
}

struct ielem   *
idelelem(struct ielem * a)
{
	struct ielem   *b;
	if (a == NULL)
		return NULL;
	b = NULL;
	if (a->next != NULL) {
		a->next->prev = a->prev;
		b = a->next;
	}
	if (a->prev != NULL) {
		a->prev->next = a->next;
		b = a->prev;
	}
	free(a, M_TEMP);
	return b;
}

struct ielem   *
iseekuid(struct ielem * a, int uid)
{
	struct ielem   *b;
	if (a == NULL)
		return NULL;
	b = a;
	while (b->prev != NULL)
		b = b->prev;
	while (b != NULL) {
		if (b->uid == uid)
			break;
		b = b->next;
	}
	return b;
}

struct ielem   *
iseeknextuid(struct ielem * a, int uid)
{
	struct ielem   *b;
	if (a == NULL)
		return NULL;
	b = a->next;
	while (b != NULL) {
		if (b->uid == uid)
			break;
		b = b->next;
	}
	return b;
}

void 
idelall(struct ielem * a)
{
	struct ielem   *b;
	if (a == NULL)
		return;
	while (a->prev != NULL)
		a = a->prev;
	do {
		b = a->next;
		free(a, M_TEMP);
		a = b;
	} while (a != NULL);
}

void 
iprintall(struct ielem * a)
{
	struct ielem   *b;
	if (a == NULL)
		return;
	b = a;
	while (b->prev != NULL)
		b = b->prev;
	do {
		printf("UID: %d -> inode: %d, device: %d\n", b->uid, b->inode, b->device);
		b = b->next;
	} while (b != NULL);
}
