#include "keflist.h"
#include <sys/null.h>
#include <sys/systm.h>
#include <sys/malloc.h>

struct elem    *
addelem(struct elem * a, int uid, char *path)
{
	struct elem    *b;
	b = (struct elem *) malloc(sizeof(struct elem), M_TEMP, M_WAITOK);
	b->uid = uid;
	strcpy(b->path, path);
	b->next = NULL;
	b->prev = a;
	if (a != NULL) {
		while (a->next != NULL)
			a = a->next;
		a->next = b;
	}
	return b;
}

struct elem    *
delelem(struct elem * a)
{
	struct elem    *b;
	if (a == NULL)
		return NULL;
	b = NULL;
	if (a->next != NULL) {
		a->next->prev = a->prev;
		b = a->next;
	}
	if (a->prev != NULL) {
		a->prev->next = a->next;
		b = a->prev;
	}
	free(a, M_TEMP);
	return b;
}

struct elem    *
seekuid(struct elem * a, int uid)
{
	struct elem    *b;
	if (a == NULL)
		return NULL;
	b = a;
	while (b->prev != NULL)
		b = b->prev;
	while (b != NULL) {
		if (b->uid == uid)
			break;
		b = b->next;
	}
	return b;
}

struct elem    *
seeknextuid(struct elem * a, int uid)
{
	struct elem    *b;
	if (a == NULL)
		return NULL;
	b = a->next;
	while (b != NULL) {
		if (b->uid == uid)
			break;
		b = b->next;
	}
	return b;
}

void 
delall(struct elem * a)
{
	struct elem    *b;
	if (a == NULL)
		return;
	while (a->prev != NULL)
		a = a->prev;
	do {
		b = a->next;
		free(a, M_TEMP);
		a = b;
	} while (a != NULL);
}

void 
printall(struct elem * a)
{
	struct elem    *b;
	if (a == NULL)
		return;
	b = a;
	while (b->prev != NULL)
		b = b->prev;
	do {
		printf("%d -> %s\n", b->uid, b->path);
		b = b->next;
	} while (b != NULL);
}
