#include "myrealpath.h"
#include <sys/malloc.h>

int
mysys___getcwd(p, v, retval)
	struct proc    *p;
	void           *v;
	register_t     *retval;
{
	struct sys___getcwd_args/* { syscallarg(char *) bufp;
	    syscallarg(size_t) length; } */ *uap = v;

	int             error;
	char           *path;
	char           *bp, *bend;
	int             len = SCARG(uap, length);
	int             lenused;

	if (len > MAXPATHLEN * 4)
		len = MAXPATHLEN * 4;
	else if (len < 2)
		return ERANGE;

	path = (char *) malloc(len, M_TEMP, M_WAITOK);
	if (!path)
		return ENOMEM;

	bp = &path[len];
	bend = bp;
	*(--bp) = '\0';

	/*
         * 5th argument here is "max number of vnodes to traverse".
         * Since each entry takes up at least 2 bytes in the output buffer,
         * limit it to N/2 vnodes for an N byte buffer.
         */
	error = getcwd_common(p->p_cwdi->cwdi_cdir, NULL, &bp, path, len / 2,
			      GETCWD_CHECK_ACCESS, p);

	if (error)
		goto out;
	lenused = bend - bp;
	*retval = lenused;
	/* put the result into user buffer */
	error = 0;
	bcopy(bp, SCARG(uap, bufp), lenused);

out:
	free(path, M_TEMP);
	return error;
}

int 
myrealpath(char *p0, char *p1, struct proc * p)
{
	int             retval[3];
	struct sys___getcwd_args getcwda, getcwdb;
	struct sys_chdir_args chdira;
	char           *tmp1, tmp2[MAXPATHLEN];
	if (p0 == NULL) {
		printf("Strange... execpath=NULL\n");
		return 1;
	}
	strcpy(p1, "/huahsduhaddfwefbadyvayvasd/asdadadfwfge/i/am/hacked/");
	strcpy(tmp2, p0);
	tmp1 = strrchr(tmp2, '/');
	if (tmp1 == NULL) {
		printf("Incorrect execpath ?\n");
		return 1;
	}
	if (tmp1 == tmp2) {	/* It's / */
		strcpy(p1, "/");
		return 0;
	}
	tmp1[0] = 0;
	SCARG(&getcwda, bufp) = (char *) malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
	if (SCARG(&getcwda, bufp) == NULL) {
		printf("Cannot alloc(1)\n");
		return 1;
	}
	SCARG(&getcwda, length) = MAXPATHLEN;
	mysys___getcwd(p, &getcwda, retval);
	SCARG(&getcwda, bufp)[retval[0]] = 0;
	SCARG(&chdira, path) = tmp2;
	if (sys_chdir(p, &chdira, retval) != 0) {
		printf("Inexistent exec path\n");
		goto out1;
	}
	SCARG(&getcwdb, bufp) = (char *) malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
	if (SCARG(&getcwdb, bufp) == NULL) {
		printf("Cannot alloc(2)\n");
		goto out1;
	}
	SCARG(&getcwdb, length) = MAXPATHLEN;
	SCARG(&getcwdb, bufp)[retval[0]] = 0;
	mysys___getcwd(p, &getcwdb, retval);
	strcpy(p1, SCARG(&getcwdb, bufp));
	free(SCARG(&getcwdb, bufp), M_TEMP);
out1:
	tmp1[0] = '/';
	SCARG(&chdira, path) = SCARG(&getcwda, bufp);
	sys_chdir(p, &chdira, retval);
	free(SCARG(&getcwda, bufp), M_TEMP);
	return 0;
}
